Imports System
Imports System.Management

Public Class networkAdapter
    Inherits objectManagement

    Public adapterCollection As New adaptersCollection
    
    Public Sub New()
        'ciclo sull'elenco degli adapter e li inserisco nella collection
        Dim obj As ManagementObject
        Dim oq As New SelectQuery("Win32_NetworkAdapter")
        Dim searcher As New ManagementObjectSearcher(oq)
        For Each obj In searcher.Get()
            'ricavo l'elenco dei device
            Dim objManage As New objectManagement(obj("DeviceID"))
            adapterCollection.Add(New adapter(objManage.objWMI))
        Next
    End Sub

End Class

#Region "Classe adapter"

Public Class adapter

    Private strDeviceID As UInt32
    Private strDescription As String
    Private strMACAddress As String
    Private strIPAddress As String()
    Private strIPSubnet As String()
    Private strDefaultIPGateway As String()
    Private myObj As ManagementObject

    Public Sub New(ByVal objWMI As ManagementBaseObject)
        strMACAddress = objWMI("MACAddress")
        strIPAddress = objWMI("IPAddress")
        strIPSubnet = objWMI("IPSubnet")
        strDefaultIPGateway = objWMI("DefaultIPGateway")
        strDescription = objWMI("Description")
        strDeviceID = objWMI("Index")
        myObj = objWMI
    End Sub

    Public Sub setIP(ByVal address As String, ByVal subnet As String, ByVal gateway As String)

        Dim myParamsIn As ManagementBaseObject
        Dim myParamsOut(1) As ManagementBaseObject

        myParamsIn = myObj.GetMethodParameters("EnableStatic")

        myParamsIn("IPAddress") = New String() {address}

        myParamsIn("SubnetMask") = New String() {subnet}

        myParamsOut(0) = myObj.InvokeMethod("EnableStatic", myParamsIn, Nothing)

        myParamsIn = myObj.GetMethodParameters("SetGateways")

        myParamsIn("DefaultIPGateway") = New String() {gateway}

        myParamsIn("GatewayCostMetric") = New Integer() {1}

        myParamsOut(1) = myObj.InvokeMethod("SetGateways", myParamsIn, Nothing)

    End Sub

    Public Sub setDHCP()
        Dim myParamsIn As ManagementBaseObject
        Dim myParamsOut As ManagementBaseObject

        myParamsIn = myObj.GetMethodParameters("EnableDHCP")
        myParamsOut = myObj.InvokeMethod("EnableDHCP", myParamsIn, Nothing)
    End Sub

    Public ReadOnly Property objWMI() As ManagementObject
        Get
            Return myObj
        End Get
    End Property

    Public ReadOnly Property DeviceID() As String
        Get
            Return strDeviceID.ToString
        End Get
    End Property

    Public ReadOnly Property Description() As String
        Get
            Return strDescription
        End Get
    End Property

    Public ReadOnly Property MACAddress() As String
        Get
            Return strMACAddress
        End Get
    End Property

    Public ReadOnly Property IPAddress() As String()
        Get
            Return strIPAddress
        End Get
    End Property

    Public ReadOnly Property IPSubnet() As String()
        Get
            Return strIPSubnet
        End Get
    End Property

    Public ReadOnly Property DefaultIPGateway() As String()
        Get
            Return strDefaultIPGateway
        End Get
    End Property

End Class


#End Region

#Region "Collection Network Adapters"

Public Class adaptersCollection
    Inherits CollectionBase

    Public Sub Add(ByVal adapterItem As adapter)
        List.Add(adapterItem)
    End Sub

    Public Function Remove(ByVal index As Integer) As Boolean
        If (index > Count - 1 Or index < 0) Then
            Return False
        Else
            List.RemoveAt(index)
            Return True
        End If
    End Function

    Public Function getItem(ByVal index As Integer) As adapter
        Return CType(List(index), adapter)
    End Function

    Public Function findByDeviceID(ByVal strDeviceID As String) As adapter
        Dim myAdapt As adapter
        For Each objAdapt As adapter In list
            If objAdapt.DeviceID = strDeviceID Then
                myAdapt = objAdapt
                Exit For
            End If
        Next
        Return myAdapt
    End Function

End Class

#End Region

